Subject: Re: [PATCH RFC 0/2] Makefile: deprecate autoconf build infrastructure

From: Patrick Steinhardt <[email-masked]>
Date: Wed, 11 Mar 2026 08:51:23 +0100

On Wed, Mar 04, 2026 at 10:10:50AM -0800, Junio C Hamano wrote:
> Patrick Steinhardt <[email-masked]> writes:
> 
> > roundabout 1.5 years ago we had a long discussion that eventually led to
> > a rough consensus that we'd rather want to get rid of our autoconf build
> > infrastucture. This eventually led to the introduction of Meson to cover
> > this use case, which has stabilized for quite a while by now.
> >
> > This patch series thus starts the deprecation period of the autoconf
> > build infrastructure. Target for removal is Git 2.55 for now, but I'm
> > very open for discussions here. I also assume that depending on feedback
> > from packagers we may need to adapt the timeline.
> 
> I do not consider autoconf a thing on its own; rather it is a mere
> extension to Makefile based build, isn't it?  So the declaration to
> say "we favor meson over autoconf" makes little sense, at least to
> me.

Yeah, that's why I mentioned 3.5 build systems. I don't consider it to
be a full build system itself, but rather the .5 part.

> Asking which between Makefile and Meson should be the "primary"
> build environment is a different story, and the question does make
> sense, even though my answer may be different from yours ;-)

My intent isn't really to push Meson instead of our Makefile, only Meson
instead of the autoconf infra. I would claim it's the least-loved part
of our build infra overall, and it's both hard to read and write. Our
recommendation typically is to use the Makefile directly, and from my
perception I think that past discussions seemed to be in favor of
getting rid of autoconf eventually. I think we're now in a good position
to do that, but you or others may of course disagree.

Patrick